package sp_upg_2;


import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class ZobrazeniMapy extends JFrame {
	private static final long serialVersionUID = 1L;

	int WIDTH = 1000;
	int HEIGHT = 800;
	JPanel drawingArea;
	JPanel tlacitka;
	ArrayList<Kraj> kraje;

	public ZobrazeniMapy() {
		// pripraveni vykreslovaci oblasti
		this.drawingArea = new JPanel();
		this.tlacitka = new JPanel();
		
		this.drawingArea.setPreferredSize(new Dimension(WIDTH-200, HEIGHT-200));
		this.add(drawingArea);
	
		
		
		this.pack();

		this.setTitle("Mapa CR");
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);

		this.kraje = new ArrayList<Kraj>();

	}

	/**
	 * Otevre zadany soubor, nacte z nej udaje o krajich a ulozi jako jednotlive
	 * instance tridy Kraj.
	 * 
	 * @param cesta
	 *            Cesta k textovemu soboru s daty
	 */
	public void nactiData(String cesta) {

		Scanner sc = null;
		try {
			sc = new Scanner(new File(cesta));
		} catch (Exception e) {
			System.out
					.println("Soubor se nepodarilo precist. Program bude ukoncen");
			System.exit(1);
		}
		try {
			String nazevKraje;
			
			while ((nazevKraje = sc.nextLine().trim()).length() != 0) {

				String radkaSBody = sc.nextLine().trim();

				radkaSBody = radkaSBody.substring(1, radkaSBody.length() - 1);

				String bodyString[] = radkaSBody.split("\\),\\(");
				
				Point2D.Double body[] = new Point2D.Double[bodyString.length];
				
				for (int i = 0; i < body.length; i++) {

					String bod[] = bodyString[i].split(",");

					body[i] = new Point2D.Double(Double.parseDouble(bod[1]),
							Double.parseDouble(bod[0]));
				}

				
				this.kraje.add(new Kraj(nazevKraje, body));
                                

			}

		} catch (Exception e) {
			e.printStackTrace();
			System.out
					.println("Soubor neni v predpokladanem formatu. Program bude ukoncen");
			System.exit(1);
		}
	}

	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2 = (Graphics2D) drawingArea.getGraphics();
		// vykreslime prvni nacteny kraj
		int x =0;
		int y = -330;
		
		
		kraje.get(9).vykresli(g2, 40 * 8, 300, 30, 50+x, 463+y); // PLZENSKY KRAJ
		kraje.get(10).vykresli(g2, 400, 300, 30, 155+x, 350+y); // STREDOCESKY
		kraje.get(11).vykresli(g2, 360, 310, 30, 105+x, 255+y); // USTECKY
		kraje.get(8).vykresli(g2, 265, 300, 30, 23+x, 290+y); // KARLOVARSKY
		kraje.get(6).vykresli(g2, 290, 310, 30, 240+x, 190+y); // LIBERECKY
		kraje.get(4).vykresli(g2, 305, 300, 30, 315+x, 265+y); // KRALOVEHRADECKY
		kraje.get(5).vykresli(g2, 320, 350, 30, 340+x, 293+y); // PARDUBICKY
		kraje.get(3).vykresli(g2, 340, 300, 30, 294+x, 455+y); // VYSOCINA			
		kraje.get(0).vykresli(g2, 450, 300, 30, 473+x, 420+y); // OLOMOUCKY
		kraje.get(7).vykresli(g2, 430, 300, 30, 170+x, 508+y); // JIHOCESKY
		kraje.get(2).vykresli(g2, 290, 300, 30, 510+x, 478+y); // ZLINSKY
		kraje.get(1).vykresli(g2, 390, 300, 30, 370+x, 475+y); // JIHOMORAVSKY	
		kraje.get(13).vykresli(g2, 395, 300, 30, 520+x, 388+y); // MORAVSKSLEZKY
		kraje.get(12).vykresli(g2, 150, 300, 30, 235+x, 290+y); // PRAHA
		
		
		

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		ZobrazeniMapy o = new ZobrazeniMapy();
		// nacteni dat
		o.nactiData("C:/Users/LEFI/Desktop/kraje_cr.txt");

		o.setVisible(true);
	}


}
